#include<stdio.h>
#include<string>


namespace std{
	template<class T1,class T2>
	struct concatenator{
		T1 &p1;
		T2 &p2;
		typedef std::string::iterator itt;
		template<class T>int get_size(T &obj) {return get_size(obj.p1)+get_size(obj.p2);}
		int get_size(std::string &s) {return s.size();}
		int get_size(const char &s) {return strlen(&s);}
		concatenator(T1 &s1,T2 &s2):p1(s1),p2(s2) {}
		int size() {return p1.size()+p2.size();}
		template<class T_1,class T_2>
		itt set(concatenator<T_1,T_2>*obj,itt it) {return set(&obj->p2,set(&obj->p1,it));}
		itt set(std::string*s,itt it) {return std::copy(s->begin(),s->end(),it);}
		itt set(const char *t,itt it) {return std::copy(t,strchr(t,0),it);}
		operator std::string() {
			std::string obj;
			obj.resize(get_size(*this));
			set(this,obj.begin());
			return obj;
		}
	};
}

template<class T>static std::concatenator<T,std::string>operator+(T &a,std::string &b) {
	return std::concatenator<T,std::string>(a,b);
}
template<class T>static std::concatenator<T,const char>operator+(T &a,const char *b) {
	return std::concatenator<T,const char>(a,*b);
}

int main()
{
	std::string a("1"),b("22"),c("333"),d("4444"),e("55555"),f("666666");
	std::string r=a+b+c+d+e+f+"-test-";
	printf("%s\n",r.data());
    return 0;
}


